<script lang="ts">
import Component from 'vue-class-component';
import { Prop, Watch } from 'vue-property-decorator';
import type {
  Unit, Onset, Pixel, Rect,
} from '@/data';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Sends events with the current onset when the user or program scrolls
 *
 * Allows updating the url
 */
@Component
export default class BSendOnsetOnScroll extends LabelBehavior {
  @Watch('viewRect.x')
  onScroll() {
    const p = this.viewRect.x;

    if (this.pixelUnit.isOutOfBounds(p)) {
      this.emitScrollOnset(null);
    } else {
      this.emitScrollOnset(this.pixelUnit.toOnset(p).value);
    }
  }

  emitScrollOnset(onset: Onset | null) {
    this.$emit('scroll-onset', onset);
  }

  @Prop()
  viewRect!: Rect;

  @Prop()
  pixelUnit!: Unit<Pixel>;
}
</script>
